﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Notatnik.NET
{
    public partial class Form1 : Form
    {
        string ścieżkaPliku = "";
        bool tekstZmieniony = false;
        
        public Form1()
        {
            InitializeComponent();
            //okno.Text = "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW";
        }

        #region Metody pomocnicze
        private void ustalTytułOkna()
        {
            this.Text =
                Path.GetFileName(ścieżkaPliku) +
                (tekstZmieniony ? "*" : "") +
                " - Notatnik.NET";
        }

        private bool zapiszDoPlikuJako()
        {
            //if (!string.IsNullOrWhiteSpace(ścieżkaPliku))
            if (File.Exists(ścieżkaPliku))
            {
                saveFileDialog1.InitialDirectory = Path.GetDirectoryName(ścieżkaPliku);
                saveFileDialog1.FileName = Path.GetFileName(ścieżkaPliku);
            }
            else
            {
                saveFileDialog1.FileName = "";
            }
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                okno.ReadOnly = false;
                if (saveFileDialog1.FileName.EndsWith(".rtf"))
                {
                    okno.SaveFile(saveFileDialog1.FileName);
                }
                if (saveFileDialog1.FileName.EndsWith(".txt"))
                {
                    File.WriteAllLines(saveFileDialog1.FileName, okno.Lines);
                }
                
                ścieżkaPliku = saveFileDialog1.FileName;
                tekstZmieniony = false;
                ustalTytułOkna();
                return true;
            }
            else return false;
        }

        private bool zapiszDoPliku()
        {
            try
            {
                if (!File.Exists(ścieżkaPliku)) return zapiszDoPlikuJako();
                else
                {
                    if (ścieżkaPliku.EndsWith(".rtf"))
                    {
                        okno.SaveFile(ścieżkaPliku);
                    }
                    if (ścieżkaPliku.EndsWith(".txt"))
                    {
                        File.WriteAllLines(ścieżkaPliku, okno.Lines);
                    }
                    tekstZmieniony = false;
                    ustalTytułOkna();
                    return true;
                }
            }
            catch (Exception exc)
            {
                MessageBox.Show(
                    "Błąd podczas zapisywania: " + exc.Message,
                    this.Text,
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                return false;
            }
        }

        private bool spytajCzyZapisać()
        {
            DialogResult dr = MessageBox.Show(
                "Czy chcesz zapisać zmiany w pliku " + ścieżkaPliku + "?",
                this.Text,
                MessageBoxButtons.YesNoCancel,
                MessageBoxIcon.Question);
            switch (dr)
            {
                case DialogResult.Yes:
                    return zapiszDoPliku();
                case DialogResult.No:
                    return true;
                case DialogResult.Cancel:
                    return false;
                default:
                    throw new Exception("Nieprzewidziana wartość zmiennej 'dr'");
            }
        }

        private void wyczyśćNotatnik()
        {
            okno.Text = "";
            ścieżkaPliku = "";
            tekstZmieniony = false;
            ustalTytułOkna();
        }
        #endregion

        #region Metody zdarzeniowe
        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog1.FileName = ścieżkaPliku;
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    //
                    
                    okno.ReadOnly = openFileDialog1.ReadOnlyChecked;
                    ścieżkaPliku = openFileDialog1.FileName;                    
                    tekstZmieniony = false;
                    if (ścieżkaPliku.EndsWith(".rtf"))
                        okno.LoadFile(openFileDialog1.FileName);
                    if (ścieżkaPliku.EndsWith(".txt"))
                        okno.Lines = File.ReadAllLines(openFileDialog1.FileName);
                    ustalTytułOkna();
                }
            }
            catch(Exception exc)
            {
                MessageBox.Show(
                    "Błąd odczytu pliku: " + exc.Message,
                    this.Text,
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }
        }

        private void zapiszJakoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //zawartość przeniesiona do osobnej metody
            zapiszDoPlikuJako();
        }

        private void zmieńKolorTła(object sender, EventArgs e)
        {
            colorDialog1.Color = okno.BackColor;
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                okno.BackColor = colorDialog1.Color;
            }
        }

        private void kolorTłaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fontDialog1.Font = okno.Font;
            fontDialog1.Color = okno.ForeColor;
            if(fontDialog1.ShowDialog() == DialogResult.OK)
            {
                // okno.SelectionColor = Color.Red;


                okno.SelectionFont = fontDialog1.Font;
                okno.SelectionColor = fontDialog1.Color; // = fontDialog1.Font;
                //okno.ForeColor = fontDialog1.Color;
            }
        }

        private void zawijanieWierszyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //zawijanieWierszyToolStripMenuItem.Checked = !zawijanieWierszyToolStripMenuItem.Checked;
            okno.WordWrap = zawijanieWierszyToolStripMenuItem.Checked;
        }

        private void zapiszToolStripMenuItem_Click(object sender, EventArgs e)
        {
            zapiszDoPliku();
        }

        private void nowyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!tekstZmieniony) wyczyśćNotatnik();
            else if (spytajCzyZapisać()) wyczyśćNotatnik();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            tekstZmieniony = true;
            ustalTytułOkna();
        }

        private void zakończToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!tekstZmieniony) Close();
            else if (spytajCzyZapisać()) Close();
        }
        #endregion
    }
}
